
; Definitionen fr Mega8

; Belegungen der Atmel-Ports:

;*****************************************************************

;	PB0		ICP1
;   PB1		OC1A
;   PB2		SS		OC1B
;   PB3		OC2		MOSI
;   PB4		MISO
;	PB5		SCK		
;	PB6		TOSC1	XTAL1
;	PB7		TOSC2	XTAL2

;	PC0		ADC0				RFM12 SDI	[SDI]
;	PC1		ADC1				RFM12 SCK	[SCK]
;	PC2		ADC2				RFM12 SDO	[SDO]
;	PC3		ADC3				RFM12 CS	[nSEL]
;	PC4		ADC4	SDA
;	PC5		ADC5	SCL
;	PC6		RESET

;	PD0		RXD											FTDI TxD
;	PD1		TXD											FTDI RxD
;	PD2		INT0				RFM12 IRQ	[nIRQ]
;	PD3		INT1
;	PD4		T0		XCK
;	PD5		T1
;	PD6		AIN0
;	PD7		AIN1

	
// nFFS: 1-10k Pullup an Vcc !!!

;*****************************************************************

;--- Allgemeines -----------------------------------------------

.equ    F_CPU           = 14745600
.equ    CYCLES_PER_US   = ((F_CPU+500000)/1000000)

.equ    UART_BAUD_RATE  = 38400
.equ    UART_BAUD_SELECT= (F_CPU/(UART_BAUD_RATE*16))-1

;**************************** Port-Bits ***************************

.equ	RFM12_PORT		= PORTC
.equ	RFM12_PIN		= PINC

.equ	RFM12_SDI		= PC0
.equ	RFM12_SCK		= PC1
.equ	RFM12_SDO		= PC2
.equ	RFM12_CS		= PC3

.equ	RFM12_IRQ_PIN	= PIND
.equ	RFM12_IRQ_IN	= PD2


;***************************** FLAGS IRQ **************************

;***************************** FLAGS ******************************

;**************************** Ram-Reservierungen ******************

;--- Internes Ram ------------------------------------------------

.DSEG

.ORG    0x060										; 160 Byte allgemein

DATA_BUF:	.byte	64

;**************************** Register ****************************

;--- lower Register -----------------------------------------------

.def	SREG_SAVE	= r0
.def	NULL		= r1

;--- higher Register ----------------------------------------------

.def	FLAGS		= r16							; Flags fr Funktionen

.def	TEMP_3		= r22                   		; Temp-Register
.def	TEMP_2		= r23                   		; Temp-Register
.def	TEMP_1		= r24                   		; Temp-Register
.def	TEMP_0		= r25							; Temp-Register

; r26/r27, r28/r29, r30/r31 fr X,Y,Z reserviert 

;--- Macros -------------------------------------------------------

.macro  load_p                      ; ldt 16Bit @1 nach @0 High und @0 Low

        ldi     @0H,HIGH(@1)
        ldi     @0L,LOW(@1)

.endmacro

