;************************ RFM12 Sende-Routinen *****************************

;***************************** RFM12 Send CMD ******************************
; Sub: Sendet 16Bit Kommando aus Z
; Parameter:	Z Kommando
; Return:		Y Status ???
; Scratch-Reg:	Z, TEMP_0, TEMP_1
;***************************************************************************

// nFFS: 1-10k Pullup an Vcc !!!

RFM12_send_cmd:
		cbi		RFM12_PORT,RFM12_CS

		ldi		TEMP_1,16			; Anzahl Bits

RFM12_send_cmd_loop:
		cbi		RFM12_PORT,RFM12_SDI		
		sbrc	ZH,7
		sbi		RFM12_PORT,RFM12_SDI		

		nop
		nop
		sbi		RFM12_PORT,RFM12_SCK
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		cbi		RFM12_PORT,RFM12_SCK		

		lsl		ZL
		rol		ZH

		dec		TEMP_1
		brne	RFM12_send_cmd_loop

		sbi		RFM12_PORT,RFM12_CS
		
		ret

;***************************** RFM12 Init **********************************
; Sub: Initialisiert den RFM02
; Parameter:	-
; Return:		-
; Scratch-Reg:	Z, TEMP_0, TEMP_1
;***************************************************************************

RFM12_init:
		load_p	Z,0x0000			; Status read
		rcall	RFM12_send_cmd

		load_p	Z,0xC080			; CLK-Frequenz / Batterie-Level
		rcall	RFM12_send_cmd

		load_p	Z,0x80D7			; FIFO ein, C = 11,5pF
		rcall	RFM12_send_cmd

		load_p	Z,0xC2AB			; Thresold, Filter
		rcall	RFM12_send_cmd

		load_p	Z,0xCA81			; FIFO-Level, 
		rcall	RFM12_send_cmd

		load_p	Z,0xE000			; WakeUp aus 
		rcall	RFM12_send_cmd

		load_p	Z,0xC800			; Low Duty Cycle aus, 
		rcall	RFM12_send_cmd

		load_p	Z,0xC4F3			; AFC
		rcall	RFM12_send_cmd

		load_p	Z,0xA620			; Frequenz
		rcall	RFM12_send_cmd

		load_p	Z,0x948C			; Bandbreite
		rcall	RFM12_send_cmd

		load_p	Z,0xC610			; Baudrate 19200
		rcall	RFM12_send_cmd

		ret

;************************** RFM12 Empfang Daten ****************************
; Sub: Liest Datenbyte vom RFM12
; Parameter:	-
; Return:		TEMP_0 Anzahl
; Scratch-Reg:	TEMP_0, TEMP_1
;***************************************************************************

RFM12_read_fifo:
		load_p	Y,DATA_BUF
		mov		TEMP_2,TEMP_0		; Anzahl merken

		load_p	Z,0x82C8			; Empfnger ein
		rcall	RFM12_send_cmd

		load_p	Z,0xCA81			; set FIFO mode
		rcall	RFM12_send_cmd

		load_p	Z,0xCA83			; enable FIFO
		rcall	RFM12_send_cmd

		cbi		RFM12_PORT,RFM12_SCK
		cbi		RFM12_PORT,RFM12_SDI

RFM12_read_fifo_loop:
		cbi		RFM12_PORT,RFM12_CS

RFM12_read_fifo_wait:
		sbis	RFM12_PIN,RFM12_SDO
		rjmp	RFM12_read_fifo_wait

		ldi		TEMP_1,8
		ldi		TEMP_0,0xB0					; Receive FIFO

RFM12_read_fifo_cmd:
		cbi		RFM12_PORT,RFM12_SDI
		sbrc	TEMP_0,7
		sbi		RFM12_PORT,RFM12_SDI

		nop
		nop
		sbi		RFM12_PORT,RFM12_SCK
		nop
		nop
		nop
		nop
		nop
		nop
		cbi		RFM12_PORT,RFM12_SCK
		lsl		TEMP_0
		nop
		dec		TEMP_1
		brne	RFM12_read_fifo_cmd

RFM12_read_fifo_daten_start:		
		clr		TEMP_0
		ldi		TEMP_1,8

RFM12_read_fifo_daten:
		lsl		TEMP_0
		sbic	RFM12_PIN,RFM12_SDO
		sbr		TEMP_0,0b00000001

		sbi		RFM12_PORT,RFM12_SCK
		nop
		nop
		nop
		nop
		cbi		RFM12_PORT,RFM12_SCK
		dec		TEMP_1
		brne	RFM12_read_fifo_daten

		st		Y+,TEMP_0
		sbi		RFM12_PORT,RFM12_CS

		dec		TEMP_2
		brne	RFM12_read_fifo_loop

		load_p	Z,0x8208			; Empfnger aus
		rcall	RFM12_send_cmd
								
		ret


